set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_050100 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2016.08.24'
,p_release=>'5.1.3.00.05'
,p_default_workspace_id=>1821013086265845
,p_default_application_id=>100
,p_default_owner=>'DEMO'
);
end;
/
prompt --application/ui_types
begin
null;
end;
/
prompt --application/shared_components/plugins/process_type/externalpdf76829
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6795438854568159)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'EXTERNALPDF76829'
,p_display_name=>'ExternalFOP'
,p_supported_ui_types=>'DESKTOP'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function j4l_externalpdf (',
'    p_process in apex_plugin.t_process,',
'    p_plugin  in apex_plugin.t_plugin )',
'    return apex_plugin.t_process_exec_result',
'as',
'    v_return apex_plugin.t_process_exec_result;',
'    v_serverurl varchar(100);',
'    v_query varchar(100);',
'    v_layout varchar(100);',
'    l_xmldocument blob;',
'    l_finaldocument blob;',
'    l_report clob;',
'    v_template clob;',
'    v_output varchar(30);',
'    v_suffix varchar(30);',
'begin',
'',
'v_serverurl := p_process.attribute_01;',
'v_query := p_process.attribute_02;',
'v_layout := p_process.attribute_03;',
'v_output := p_process.attribute_04;',
'',
'v_suffix := ''''; -- no suffix is PDF',
'if (v_output  = ''TRACE'') then ',
'    v_suffix := ''?TRACE=1'';',
'elsif (v_output  = ''XLS'') then ',
'    v_suffix := ''?XLS=1'';',
'end if;',
'',
'v_serverurl :=  v_serverurl  ||  v_suffix;',
'',
'',
'SELECT  PAGE_TEMPLATE INTO l_report FROM APEX_050100.WWV_FLOW_REPORT_LAYOUTS WHERE  REPORT_LAYOUT_NAME = v_layout;',
'   ',
'SYS.DBMS_LOB.CREATETEMPORARY(V_TEMPLATE, FALSE, SYS.DBMS_LOB.SESSION );',
'SYS.DBMS_LOB.OPEN(V_TEMPLATE, SYS.DBMS_LOB.LOB_READWRITE );',
'SYS.DBMS_LOB.COPY(V_TEMPLATE, l_report, SYS.DBMS_LOB.GETLENGTH(l_report) );',
'',
'',
'-- first get XML',
'      l_xmldocument := APEX_UTIL.GET_PRINT_DOCUMENT (',
'     p_application_id=> NV(''APP_ID''),',
'     p_report_query_name=> v_query,',
'     p_report_layout_name => v_layout,',
'     p_report_layout_type=> ''xsl-fo'',',
'     p_document_format=> ''XML'' ',
'     );',
'     ',
'-- this signature creates the final report, if works with p_print_server',
'    l_finaldocument := APEX_UTIL.GET_PRINT_DOCUMENT (',
'     P_REPORT_DATA=> l_xmldocument,',
'     P_REPORT_LAYOUT => V_TEMPLATE,',
'     p_report_layout_type=> ''xsl-fo'',',
'     p_document_format=> ''PDF'' ,',
'     p_print_server=> v_serverurl',
'     ); ',
'     ',
'     SYS.DBMS_LOB.CLOSE( V_TEMPLATE );',
'     SYS.DBMS_LOB.FREETEMPORARY( V_TEMPLATE );',
'',
'        sys.htp.init;  ',
'           ',
'        if (v_output = ''TRACE'') then',
'            sys.owa_util.mime_header( ''text/html'', FALSE );',
'            sys.htp.p(''Content-Disposition: inline;''); ',
'        elsif  (v_output = ''XLS'') then',
'            sys.owa_util.mime_header( ''application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'', FALSE );  ',
'            sys.htp.p(''Content-Disposition: attachment; filename="report.xlsx"'' ); ',
'        else',
'            sys.owa_util.mime_header( ''application/pdf'', FALSE );',
'            sys.htp.p(''Content-Disposition: inline;''); ',
'        end if;',
'        sys.htp.p(''Content-length: '' || sys.dbms_lob.getlength( l_finaldocument ));   ',
'        sys.owa_util.http_header_close;  ',
'  ',
'        sys.wpg_docload.download_file( l_finaldocument );  ',
'     ',
'     v_return.success_message := ''OK!'';',
'     return  v_return;',
'exception',
'    WHEN OTHERS THEN  -- handles all other errors',
'     raise_application_error(-20001,''An error was encountered creating the PDF - '' || v_serverurl || '' '' ||SQLCODE||'' -ERROR- ''||SQLERRM);',
'end j4l_externalpdf ;'))
,p_api_version=>2
,p_execution_function=>'j4l_externalpdf'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(6795614657568165)
,p_plugin_id=>wwv_flow_api.id(6795438854568159)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Server URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'http://eval.apex-reports.com/SaasFOP/ApexTrial'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(6796026381568165)
,p_plugin_id=>wwv_flow_api.id(6795438854568159)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Report query'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Tasks'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(6796458450568165)
,p_plugin_id=>wwv_flow_api.id(6795438854568159)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Report layout'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'TaskGeneric'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(6821246605187827)
,p_plugin_id=>wwv_flow_api.id(6795438854568159)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Output'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'Trace'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(6821857968188833)
,p_plugin_attribute_id=>wwv_flow_api.id(6821246605187827)
,p_display_sequence=>10
,p_display_value=>'Trace'
,p_return_value=>'TRACE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(6822273152189448)
,p_plugin_attribute_id=>wwv_flow_api.id(6821246605187827)
,p_display_sequence=>20
,p_display_value=>'PDF'
,p_return_value=>'PDF'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(6822623511190242)
,p_plugin_attribute_id=>wwv_flow_api.id(6821246605187827)
,p_display_sequence=>30
,p_display_value=>'Excel (.xlsx)'
,p_return_value=>'XLS'
);
end;
/
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false), p_is_component_import => true);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
